org.apache.fop.layoutmgr

## Interface BlockLevelEventProducer

All Superinterfaces:
  EventProducer

    public interface BlockLevelEventProducer
    extends EventProducer

Event producer interface for block-level layout managers.

### Nested Class Summary

Nested Classes
`static class` `BlockLevelEventProducer.Provider` Provider class for the event producer.

### Method Summary

All Methods Instance Methods Abstract Methods
`void` `flowNotMappingToRegionBody(Object source, String flowName, String masterName, Locator loc)` Indicates that FOP doesn't support flows that are not mapped to region-body, yet.
`void` `lastPageMasterReferenceMissing(Object source, Locator loc)` Last page master reference missing.
`void` `layoutHasReachedParts(Object source, int partCount)` A feasible layout has reached the given number of parts (columns or pages).
`void` `missingSubsequencesInPageSequenceMaster(Object source, String pageSequenceMasterName, Locator loc)` No subsequences in page sequence master.
`void` `noMatchingPageMaster(Object source, String pageSequenceMasterName, String pageMasterName, Locator loc)` No single-page-master matching in page sequence master.
`void` `nonRestartableContentFlowingToNarrowerPage(Object source)` An element that cannot handle changing IPD (list, table) is flowing to a narrower page.
`void` `objectTooWide(Object source, String elementName, int effIPD, int maxIPD, Locator loc)` An formatting object is too wide.
`void` `overconstrainedAdjustEndIndent(Object source, String elementName, int amount, Locator loc)` An overconstrained geometry adjustment rule was triggered (5.3.4, XSL 1.0).
`void` `pageSequenceMasterExhausted(Object source, String pageSequenceMasterName, boolean canRecover, Locator loc)` A page sequence master is exhausted.
`void` `regionOverflow(Object source, String elementName, String page, int amount, boolean clip, boolean canRecover, Locator loc)` Contents overflow a region viewport.
`void` `rowTooTall(Object source, int row, int effCellBPD, int maxCellBPD, Locator loc)` The contents of a table-row are too big to fit in the constraints.
`void` `staticRegionOverflow(Object source, String elementName, String page, int amount, boolean clip, boolean canRecover, Locator loc)` Contents overflow a static region viewport.
`void` `tableFixedAutoWidthNotSupported(Object source, Locator loc)` Auto-table layout is not supported, yet.
`void` `viewportBPDOverflow(Object source, String elementName, int amount, boolean clip, boolean canRecover, Locator loc)` Contents BPD overflow a viewport.
`void` `viewportIPDOverflow(Object source, String elementName, int amount, boolean clip, boolean canRecover, Locator loc)` Contents IPD overflow a viewport.

### Method Detail

#### rowTooTall

    void rowTooTall(Object source,
                    int row,
                    int effCellBPD,
                    int maxCellBPD,
                    Locator loc)

The contents of a table-row are too big to fit in the constraints.

Parameters:
  `source` - the event source
  `row` - the row number
  `effCellBPD` - the effective extent in block-progression direction of the cell
  `maxCellBPD` - the maximum extent in block-progression direction of the cell
  `loc` - the location of the error or null
Event.severity:
  WARN

#### tableFixedAutoWidthNotSupported

    void tableFixedAutoWidthNotSupported(Object source,
                                         Locator loc)

Auto-table layout is not supported, yet.

Parameters:
  `source` - the event source
  `loc` - the location of the error or null
Event.severity:
  INFO

#### objectTooWide

    void objectTooWide(Object source,
                       String elementName,
                       int effIPD,
                       int maxIPD,
                       Locator loc)

An formatting object is too wide.

Parameters:
  `source` - the event source
  `elementName` - the formatting object
  `effIPD` - the effective extent in inline-progression direction of the table contents
  `maxIPD` - the maximum extent in inline-progression direction available
  `loc` - the location of the error or null
Event.severity:
  WARN

#### overconstrainedAdjustEndIndent

    void overconstrainedAdjustEndIndent(Object source,
                                        String elementName,
                                        int amount,
                                        Locator loc)

An overconstrained geometry adjustment rule was triggered (5.3.4, XSL 1.0).

Parameters:
  `source` - the event source
  `elementName` - the formatting object
  `amount` - the amount of the adjustment (in mpt)
  `loc` - the location of the error or null
Event.severity:
  INFO

#### viewportIPDOverflow

    void viewportIPDOverflow(Object source,
                             String elementName,
                             int amount,
                             boolean clip,
                             boolean canRecover,
                             Locator loc)

Contents IPD overflow a viewport.

Parameters:
  `source` - the event source
  `elementName` - the formatting object
  `amount` - the amount by which the contents overflow (in mpt)
  `clip` - true if the content will be clipped
  `canRecover` - indicates whether FOP can recover from this problem and continue working
  `loc` - the location of the error or null
Event.severity:
  ERROR

#### viewportBPDOverflow

    void viewportBPDOverflow(Object source,
                             String elementName,
                             int amount,
                             boolean clip,
                             boolean canRecover,
                             Locator loc)

Contents BPD overflow a viewport.

Parameters:
  `source` - the event source
  `elementName` - the formatting object
  `amount` - the amount by which the contents overflow (in mpt)
  `clip` - true if the content will be clipped
  `canRecover` - indicates whether FOP can recover from this problem and continue working
  `loc` - the location of the error or null
Event.severity:
  ERROR

#### regionOverflow

    void regionOverflow(Object source,
                        String elementName,
                        String page,
                        int amount,
                        boolean clip,
                        boolean canRecover,
                        Locator loc)
                 throws LayoutException

Contents overflow a region viewport.

Parameters:
  `source` - the event source
  `elementName` - the formatting object
  `page` - the page number/name where the overflow happened
  `amount` - the amount by which the contents overflow (in mpt)
  `clip` - true if the content will be clipped
  `canRecover` - indicates whether FOP can recover from this problem and continue working
  `loc` - the location of the error or null
Throws:
  `LayoutException` - the layout error provoked by the method call
Event.severity:
  FATAL

#### staticRegionOverflow

    void staticRegionOverflow(Object source,
                              String elementName,
                              String page,
                              int amount,
                              boolean clip,
                              boolean canRecover,
                              Locator loc)
                       throws LayoutException

Contents overflow a static region viewport.

Parameters:
  `source` - the event source
  `elementName` - the formatting object
  `page` - the page number/name where the overflow happened
  `amount` - the amount by which the contents overflow (in mpt)
  `clip` - true if the content will be clipped
  `canRecover` - indicates whether FOP can recover from this problem and continue working
  `loc` - the location of the error or null
Throws:
  `LayoutException` - the layout error provoked by the method call
Event.severity:
  FATAL

#### flowNotMappingToRegionBody

    void flowNotMappingToRegionBody(Object source,
                                    String flowName,
                                    String masterName,
                                    Locator loc)
                             throws UnsupportedOperationException

Indicates that FOP doesn't support flows that are not mapped to region-body, yet.

Parameters:
  `source` - the event source
  `flowName` - the flow name
  `masterName` - the page master name
  `loc` - the location of the error or null
Throws:
  `UnsupportedOperationException` - the layout error provoked by the method call
Event.severity:
  FATAL

#### pageSequenceMasterExhausted

    void pageSequenceMasterExhausted(Object source,
                                     String pageSequenceMasterName,
                                     boolean canRecover,
                                     Locator loc)
                              throws PageProductionException

A page sequence master is exhausted.

Parameters:
  `source` - the event source
  `pageSequenceMasterName` - the name of the page sequence master
  `canRecover` - indicates whether FOP can recover from this problem and continue working
  `loc` - the location of the error or null
Throws:
  `PageProductionException` - the error provoked by the method call
Event.severity:
  FATAL

#### missingSubsequencesInPageSequenceMaster

    void missingSubsequencesInPageSequenceMaster(Object source,
                                                 String pageSequenceMasterName,
                                                 Locator loc)
                                          throws PageProductionException

No subsequences in page sequence master.

Parameters:
  `source` - the event source
  `pageSequenceMasterName` - the name of the page sequence master
  `loc` - the location of the error or null
Throws:
  `PageProductionException` - the error provoked by the method call
Event.severity:
  FATAL

#### noMatchingPageMaster

    void noMatchingPageMaster(Object source,
                              String pageSequenceMasterName,
                              String pageMasterName,
                              Locator loc)
                       throws PageProductionException

No single-page-master matching in page sequence master.

Parameters:
  `source` - the event source
  `pageSequenceMasterName` - the name of the page sequence master
  `pageMasterName` - the name of the page master not matching
  `loc` - the location of the error or null
Throws:
  `PageProductionException` - the error provoked by the method call
Event.severity:
  FATAL

#### nonRestartableContentFlowingToNarrowerPage

    void nonRestartableContentFlowingToNarrowerPage(Object source)

An element that cannot handle changing IPD (list, table) is flowing to a narrower page. Some content may be lost.

Parameters:
  `source` - the event source
Event.severity:
  WARN

#### layoutHasReachedParts

    void layoutHasReachedParts(Object source,
                               int partCount)

A feasible layout has reached the given number of parts (columns or pages).

Parameters:
  `source` - the event source
  `partCount` - the number of parts that the layout has reached
Event.severity:
  INFO

#### lastPageMasterReferenceMissing

    void lastPageMasterReferenceMissing(Object source,
                                        Locator loc)

Last page master reference missing.

Parameters:
  `source` - the event source
Event.severity:
  WARN